<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Overview</TITLE>
<link href="lic_7.html" rel=Next>
<link href="lic_5.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_5.html">previous</A>, <A HREF="lic_7.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC6" HREF="lic_toc.html#TOC6">Overview</A></H2>
<P>
<A NAME="IDX36"></A>

</P>
<P>
An overview of the rapid prototyping system is presented by showing how
to solve the following simple problem.

</P>
<P>
The following system of inequalities describing a convex polyhedron
representing a two dimensional iteration space (<SAMP>`i'</SAMP>, <SAMP>`j'</SAMP>)
is given as the input. 

<UL>
<LI>i &#62;= 1

<LI>i &#60;= N

<LI>j &#62;= i

<LI>j &#62;= N - i

<LI>j &#60;= 2*i + 1

</UL>

<P>
First, we will find if there exists an integer solution for
this system of inequalities, i.e. if there are any valid iterations
within this space. 

</P>
<P>
Next, we will explore two different methods to scan the iteration space.
In the first method, a loop nest is created with <SAMP>`i'</SAMP> outermost and
<SAMP>`j'</SAMP> innermost.  In the second method we will produce a loop nest
where <SAMP>`j'</SAMP> is outermost and <SAMP>`i'</SAMP> is innermost.

</P>
<P>
Here is the <CODE>LIC</CODE> session that is used to perform the above
mentioned tasks.

</P>

<PRE>
csh&#62; lic -c
Rapid Prototyping System for Code Generation
&#62; iter = [ 1     &#60;= i &#60;= N
           i     &#60;= j
           N - i &#60;= j
                    j &#60;= 2*i + 1 ]
1+2*i-j &#62;= 0
i+j-N &#62;= 0
-i+j &#62;= 0
-i+N &#62;= 0
-1+i &#62;= 0
&#62; iter.intsol()
1
&#62; #iter = iter.order(N i j)
&#62; iter.code(2)

for(i = max(1, (1+N)/3); i &#60;= N; i++)
   for(j = max(N-i, i); j &#60;= 1+2*i; j++)

&#62; #iter = iter.order(N j i)
&#62; iter.code(2)

for(j = (1+N)/2; j &#60;= 1+2*N; j++)
   for(i = max(1, N-j, j/2); i &#60;= min(j, N); i++)

&#62; quit
done(0)
csh&#62;
</PRE>

<P>
<A NAME="IDX37"></A>

</P>

<OL>
<LI>

<CODE>LIC</CODE> is invoked for Prototyping system mode

<LI>

The system of inequalities was entered into the system.  The system was
assigned to the inequality variable <SAMP>`iter'</SAMP>. <CODE>LIC</CODE> will print
the contents of the variable <SAMP>`iter'</SAMP> after it is created.

<LI>

Applying the function <SAMP>`intsol()'</SAMP> to <SAMP>`iter'</SAMP> will determine if
there exists an integer solution for the system. <CODE>LIC</CODE> prints 1
indicating that there is an integer solution to the system.

<LI>

Order the inequalities in <SAMP>`iter'</SAMP> such that the variables within the
inequalities are arranged with <SAMP>`N'</SAMP> outermost and <SAMP>`j'</SAMP> innermost
and assign it back to <SAMP>`iter'</SAMP>. Note that <SAMP>`#'</SAMP> at the beginning of
the line stops <CODE>LIC</CODE> from printing the results of the expression
evaluated by that line.

<LI>

Print the loop nest that will scan the system of inequalities in
<SAMP>`iter'</SAMP> in the order given by the previous <SAMP>`order()'</SAMP> command.
Note that <SAMP>`code(2)'</SAMP> will print only the 2nd and 3rd variables
of the system, thus omitting the constant <SAMP>`N'</SAMP>.

<LI>

The inequalities in <SAMP>`iter'</SAMP> are reordered such that <SAMP>`i'</SAMP> is
innermost.

<LI>

Print the loop nest that will scan the system of inequalities in
<SAMP>`iter'</SAMP> in the order given by the previous <SAMP>`order()'</SAMP> command. 

<LI>

Exit the <CODE>LIC</CODE> program.
</OL>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_5.html">previous</A>, <A HREF="lic_7.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
